//+------------------------------------------------------------------+
//|                                              FxCraft PL Zone.mq4 |
//|                                              http://fxcraft.biz/ |
//|                                                           v. 1.3 |
//+------------------------------------------------------------------+
//|                                                                  |
//| Licence is available at:                                         |
//| http://fxcraft.biz/licence_free_indicator                        |
//| Licencja jest dostpna pod adresem:                              |
//| http://fxcraft.biz/licencja_darmowy_wskaznik                     |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+


#property copyright "FxCraft"
#property link      "http://fxcraft.biz/"

#property indicator_chart_window

extern color zoneProfitColor=Chartreuse;
extern color zoneLossColor=Tomato;
extern bool useCommissionsAndSwaps = true;

double pv = 1;

int init() {
   
   pv = MarketInfo(Symbol(), MODE_TICKVALUE)/(MarketInfo(Symbol(), MODE_TICKSIZE) / Point);
   
   return(0);
}

int deinit() {

   ObjectDelete("fplz_zone");   

   return(0);
}

int start() {
   
   if(countOrders()>0) {
   
    double lots=0;
    double price=0;
    
   
    for(int i=0;i<OrdersTotal();i++) {
     if(OrderSelect(i,SELECT_BY_POS)) {
      if(OrderSymbol()==Symbol()) {
       if(OrderType()==OP_BUY) {
        if(useCommissionsAndSwaps){
           price=price+(OrderOpenPrice()-Point*(OrderCommission()+OrderSwap())/(OrderLots()*pv))*OrderLots();
        }else{
           price=price+OrderOpenPrice()*OrderLots();
        }
        lots=lots+OrderLots();
       }
       if(OrderType()==OP_SELL) {
        if(useCommissionsAndSwaps){
           price=price-(OrderOpenPrice()+(OrderCommission()+OrderSwap())/(OrderLots()*pv))*OrderLots();
        }else{
           price=price-OrderOpenPrice()*OrderLots();
        }
        lots=lots-OrderLots();
       }  
      }
     }
    }
    
    double level=0;
   
    if(lots!=0) {
     level=price/lots;  
     
     if(ObjectFind("fplz_zone")==-1) {
      ObjectCreate("fplz_zone",OBJ_RECTANGLE,0,0,0,0,0);
     }
    
     ObjectSet("fplz_zone",OBJPROP_PRICE1,level);
     ObjectSet("fplz_zone",OBJPROP_TIME1,0);
     ObjectSet("fplz_zone",OBJPROP_TIME2,TimeLocal()+60*24*30*10*Period());
    
     color cl=White;
    
     if(lots>0) {
      ObjectSet("fplz_zone",OBJPROP_PRICE2,Bid);  
      if(Bid>level) {
       cl=zoneProfitColor;
      } else {
       cl=zoneLossColor;
      }
     } else {
      ObjectSet("fplz_zone",OBJPROP_PRICE2,Ask);  
      if(Ask<level) {
       cl=zoneProfitColor;
      } else {
       cl=zoneLossColor;
      }
     }
     
     ObjectSet("fplz_zone",OBJPROP_COLOR,cl);
     
     
    } else {
     deinit();
    }    
   } else {
    deinit();
   }
   
   return(0);
}

int countOrders() {

   int count=0;
 
   for(int i=0;i<OrdersTotal();i++) {
    if(OrderSelect(i,SELECT_BY_POS)) {
     if(OrderSymbol()==Symbol()) {
      count++;
     } 
    }
   }
   
   return(count);
 
}